' htm2sjis.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-06-14
' htm2sjis.VBS converts HTML file to Shift JIS.
' Usage: Start htm2sjis.VBS files...

Option Explicit
Const adSaveCreateNotExist=1
Const adSaveCreateOverWrite=2 
Const adReadAll=-1
Const adWriteChar=0
Const adWriteLine=1
Const adTypeBinary=1
Const adTypeText=2
Dim fso
Dim Stream
Dim arg
Dim Path
Dim BOM
Dim Text
Dim re
Dim Matches

If WScript.Arguments.Count=0 Then
  WScript.Echo "Usage: htm2sjis.VBS files..."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
Set Stream=CreateObject("ADODB.Stream")

For Each arg In WScript.Arguments
  Select Case LCase(fso.GetExtensionName(arg))
  Case "htm"
    Path=fso.BuildPath(fso.GetParentFolderName(arg),fso.GetBaseName(arg)&".html")
  Case Else
    Path=fso.BuildPath(fso.GetParentFolderName(arg),fso.GetBaseName(arg)&".htm")
  End Select
  Stream.Open
  Stream.Type=adTypeBinary
  Stream.LoadFromFile arg
  BOM=Stream.Read(2)
  Stream.Position=0
  Stream.Type=adTypeText
'  MsgBox Stream.Charset
  Select Case CStr(BOM)
  Case ChrB(&HFF)&ChrB(&HFE),ChrB(&HFE)&ChrB(&HFF)
  Case Else Stream.Charset="iso-8859-1"
  End Select
'  MsgBox Stream.Charset
  Select Case LCase(Stream.Charset)
  Case "iso-8859-1"
    Text=Stream.ReadText(adReadAll)
    Stream.Position=0
    Set re=New RegExp
    re.IgnoreCase=True
    re.Pattern="\bcharset\s*=\s*([-A-Za-z0-9_]+)"
    Set Matches=re.Execute(Text)
    If Matches.Count Then
      Stream.Charset=Matches(0).SubMatches(0)
    End If
  End Select
'  MsgBox Stream.Charset
  Select Case LCase(Stream.Charset)
  Case "shift_jis","x-sjis","iso-8859-1"
    Stream.SaveToFile Path,adSaveCreateOverWrite 
  Case Else
    Text=Stream.ReadText(adReadAll)
    Stream.Position=0
    Stream.Charset="shift_jis"
    Stream.WriteText "<HTML><HEAD><META http-equiv=Content-Type content=""text/html; charset=shift_jis""></HEAD></HTML>",adWriteLine
    Stream.WriteText Lint(Text),adWriteChar
    Stream.SetEOS
    Stream.SaveToFile Path,adSaveCreateOverWrite 
  End Select
  Stream.Close
Next
WScript.Quit

Function Lint(Text)
Dim k
Dim char
Dim chars
ReDim chars(Len(Text)-1)

For k=1 To Len(Text)
  char=Mid(Text,k,1)
  If Chr(Asc(char))=char Then
    chars(k-1)=char
  Else
    Select Case AscW(char)
    Case &HA0 chars(k-1)="&nbsp;"
    Case &HA9 chars(k-1)="&copy;"
    Case &HAE chars(k-1)="&reg;"
    Case Else chars(k-1)="&#"&AscW(char)&";"
    End Select
  End If
Next
Lint=Join(chars,Empty)
End Function
